"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RawDateInput = exports.DateInputInner = void 0;
const locale_1 = require("date-fns/locale");
const immutable_1 = __importDefault(require("immutable"));
const react_1 = __importDefault(require("react"));
const react_datepicker_1 = __importDefault(require("react-datepicker"));
const utility_1 = require("x25/utility");
const DateInputInner = (props) => {
    const { hideError, idFileName, customClass, indexFileName, data = immutable_1.default.Map() } = props, renderCount = react_1.default.useRef(0), value = data.get("value") || "", meta = data.get("meta") || immutable_1.default.Map(), theError = meta.get("theError"), isTouched = meta.get("isTouched"), datePickerProps = react_1.default.useMemo(() => props.componentProps, [props.componentProps]), hasError = typeof theError !== "undefined", defaultClass = "form-control w-110", showError = isTouched && hasError, theClass = `${showError ? "is-invalid" : ""} ${customClass ? customClass : defaultClass}`, theValue = react_1.default.useMemo(() => {
        const momentObj = (0, utility_1.golangDateToMoment)(value);
        if (momentObj.isValid()) {
            const selectedDate = momentObj.toDate();
            selectedDate.setHours(0, 0, 0, 0);
            return selectedDate;
        }
        return "";
    }, [value]), handleFocus = (event) => {
        if (typeof props.customOnFocus === "function") {
            props.customOnFocus(event, props.handleFocus, idFileName, indexFileName);
        }
        else {
            props.handleFocus(idFileName, indexFileName);
        }
    }, handleBlur = (event) => {
        if (typeof props.customOnBlur === "function") {
            props.customOnBlur(event, props.handleBlur, idFileName, indexFileName);
        }
        else {
            props.handleBlur(idFileName, indexFileName);
        }
    }, handleChange = (date) => {
        const dateOnChange = () => {
            props.handleChange(idFileName, indexFileName, (0, utility_1.dateToGoFormat)(date));
        };
        if (typeof props.customOnChange === "function") {
            props.customOnChange(date, dateOnChange, props.handleChange);
        }
        else {
            dateOnChange();
        }
    };
    react_1.default.useEffect(() => {
        renderCount.current += 1;
    });
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(react_datepicker_1.default, Object.assign({ className: theClass, dateFormat: "dd.MM.yyyy", id: indexFileName, locale: locale_1.ro, name: indexFileName, onBlur: handleBlur, onChange: handleChange, onFocus: handleFocus, selected: theValue }, datePickerProps)),
        !hideError && showError ? (react_1.default.createElement("span", { className: "text-danger" }, theError)) : null));
};
exports.DateInputInner = DateInputInner;
exports.RawDateInput = react_1.default.memo(exports.DateInputInner);
//# sourceMappingURL=DateInput.js.map